<script>
import { mapGetters, mapState } from 'vuex';

import AnimRigUserLibCard from '~/components/anim-rig/user-lib-card.vue';

export default {
  name: `anim-rig-user-libs-dashboard`,
  components: { AnimRigUserLibCard },
  props: {
    libs: { type: Array, required: true },
    showInactive: { type: Boolean, required: true },
  },
  data() {
    return {
      dragging: false,
      addingLibrary: false,
      newLibraryName: ``,
    }
  },
  computed: {
    ...mapGetters('projects', [ 'isWriter' ]),
    ...mapState({
      username: (state) => state.users.currentUser.username,
    }),
    localShowInactive: {
      get() {
        return this.showInactive;
      },
      set(val) {
        this.$emit(`set-inactive`, val);
      }
    },
    nLibs() {
      return this.libs.length;
    },
    iAmWriter() {
      return this.isWriter(this.username);
    },
  },
  methods: {
    startDrag (e, item) {
      e.dataTransfer.dropEffect = 'move';
      e.dataTransfer.effectAllowed = 'move';
      e.dataTransfer.setData('id', item.id);
      this.dragging = true;
    },
    onDrop (e, target) {
      let id = e.dataTransfer.getData('id');
      if (typeof id === `string`) {
        id = parseInt(id);
      }
      this.dragging = false;
      if (target !== null && id === target.id) { // cannot itself as parent!
        return;
      }
      const item = _.find(this.items, [ `id`, id ]);
      this.$emit(`set-parent-lib`, { itemId: id, parentId: (target !== null) ? target.id : null });
    },
    toggleNewLibraryForm() {
      this.addingLibrary = true;
      setTimeout(() => {
        this.$refs[`input-new-lib-name`].focus();
      }, 100);
    },
    resetNewLibraryForm() {
      this.addingLibrary = false;
      this.newLibraryName = ``;
    },
    addLibrary (e) {
      this.$emit(`add`, { name: this.newLibraryName });
      e.preventDefault();
      this.resetNewLibraryForm();
    },
    publishLibrary (idx) {
      this.$emit(`publish`, idx);
    },
    deleteLibrary (idx) {
      this.$emit(`delete`, idx);
    },
    reviveLibrary (idx) {
      this.$emit(`revive`, idx);
    },
    setLibraryName (data) {
      this.$emit(`set-name`, data);
    },
    toggleLibraryFavorite (idx, on) {
      this.$emit(`toggle-favorite`, { idx, on });
    },
    setShowInactive (e) {
      this.$emit(`set-inactive`, e.target.value === `true`);
    }
  },
}
</script>

<template>
  <cbr-dashboard
    :title="$tc(`anim-rig.user-libs.title`, 2)"
    :dragging="dragging"
    :onDrop="(e) => onDrop(e, null)"
  >
    <template v-slot:title-commands>
      <v-row align="center">
        <v-row v-if="!addingLibrary" class="mr-4" align="center" no-gutters>
          <v-switch
            v-model="localShowInactive"
            :label="$t(`common.show-inactive`)"
            class="mr-4 my-0 py-0"
            hide-details
          />
          <div class="text-sm-caption my-0 mr-4">
            {{ nLibs }} {{ $tc(`common.library`, nLibs) }}
          </div>
          <v-btn
            v-if="iAmWriter"
            fab
            x-small
            color="primary"
            :elevation="4"
            @click="toggleNewLibraryForm"
          >
            <v-icon>mdi-plus</v-icon>
          </v-btn>
        </v-row>
        <v-form v-else @submit="addLibrary" class="mr-4">
          <v-row align="center" no-gutters>
            <v-text-field
              ref="input-new-lib-name"
              v-model="newLibraryName"
              :label="$t(`common.name`)"
              required
              hide-details
              dense
            />
            <v-btn
              fab
              x-small
              outlined
              color="primary"
              :elevation="4"
              @click="resetNewLibraryForm"
              class="ml-4 mr-2"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-btn
              fab
              x-small
              color="primary"
              :elevation="4"
              type="submit"
            >
              <v-icon>mdi-check</v-icon>
            </v-btn>
          </v-row>
        </v-form>
      </v-row>
    </template>
    <div
      v-for="(lib, idx) in libs"
      :key="lib.name"
      @drop="onDrop($event, lib)"
      @dragover.prevent
      @dragenter.prevent
    >
      <anim-rig-user-lib-card
        :lib="lib"
        @publish="() => publishLibrary(idx)"
        @delete="() => deleteLibrary(idx)"
        @revive="() => reviveLibrary(idx)"
        @set-name="(name) => setLibraryName({ idx, name })"
        @toggle-favorite="(on) => toggleLibraryFavorite(idx, on)"
        draggable
        @dragstart.native="startDrag($event, lib)"
      />
    </div>
  </cbr-dashboard>
</template>
